# -*- encoding: utf-8 -*-

from django.contrib import admin

from .models import (
    Server,
    ContentFilter,
    MessageMutator,
    MessageStyle,
    DiscordChannel,
    Subscription,
    Content,
    UniqueContentRule
)


@admin.register(Server)
class ServerAdmin(admin.ModelAdmin):
    list_display = ["id", "name", "icon_hash", "active"]


@admin.register(ContentFilter)
class ContentFilterAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "server",
        "name",
        "match",
        "matching_algorithm",
        "is_insensitive",
        "is_whitelist"
    ]


@admin.register(MessageMutator)
class MessageMutatorAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "name",
        "value"
    ]


@admin.register(MessageStyle)
class MessageStyleAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "server",
        "is_embed",
        "is_hyperlinked",
        "show_author",
        "show_timestamp",
        "show_images",
        "fetch_images",
        "title_mutator",
        "description_mutator",
        "auto_created"
    ]


@admin.register(DiscordChannel)
class DiscordChannelAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "server",
        "name",
        "is_nsfw"
    ]


@admin.register(Subscription)
class Subscription(admin.ModelAdmin):
    list_display = [
        "id",
        "server",
        "name",
        "url",
        "created_at",
        "updated_at",
        "extra_notes",
        "active",
        "message_style"
    ]


@admin.register(Content)
class ContentAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "subscription",
        "item_id",
        "item_guid",
        "item_url",
        "item_title",
        "item_content_hash"
    ]


@admin.register(UniqueContentRule)
class UniqueContentRule(admin.ModelAdmin):
    list_display = [
        "id",
        "name",
        "value"
    ]
